<template>
  <v-main>
    <corpus-table
      :client="client"
      :title="title"
      :description="$t('corpus-table.default-description')"
      :items="items"
      :loading="loading"
      :corpus-data="corpusData"
      :app-name="appName"
    />
    <portal to="sidebar-title">
      Corpus
    </portal>
    <portal to="sidebar-icons">
      <span />
    </portal>
  </v-main>
</template>

<script lang="ts">
import type { Client } from '@/client';
import { ClientStatus } from '@/client';
import {
  showLogin, warnCorpusDataUnauth, warnCorpusDataServer, warnCorpusDataOther,
} from '@/components/dialogs';
import { getClient } from '@/vuejs/components/utils/nav-tools';
import { Piece } from '@/data';
import type CorpusData from '@/data/CorpusData';
import { defineComponent } from 'vue';
import type { TablePiece } from '../../components/CorpusTable.vue';
import CorpusTable from '../../components/CorpusTable.vue';

export default defineComponent({
  components: {
    CorpusTable,
  },
  data() {
    return {
      loading: true,
      items: [] as Array<Piece&TablePiece>,
      title: '',
      corpusData: null as CorpusData | null,
    };
  },
  computed: {
    client(): Client {
      return getClient(this.$route);
    },
    appName(): string {
      return this.$route.meta?.appName;
    },
  },
  watch: {
    $route: [{
      handler: 'init',
    }],
    '$i18n.locale': [{
      handler: 'init',
    }],
  },
  async created() {
    await this.init();
  },
  methods: {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    async loadCorpus(data: any, path = 'corpus', corpusFilter: string | null = null) {
      const corpusData = await this.client.loadShowcaseCorpus();

      data.pieces?.forEach((element: Piece&TablePiece) => {
        const splittedCorpus = element.path.split('/');
        const corpus = splittedCorpus[splittedCorpus.length - 2];

        if (element.id !== 'test' && (corpusFilter === null || corpus === corpusFilter || element.path.includes(corpusFilter))) {
          const corpusTitle = corpusData
            .find((cd) => cd.id === corpus)?.getTitle(this.$i18n.locale) || null;
          // remove "test" entries to prevent from duplicate issues
          this.items.push({
            ...element,
            uniqueId: `${element.path}/${element.id}`,
            analyses: [],
            corpus: corpusTitle || corpus,
            corpusLink: corpusTitle ? corpus : null,
            absoluteId: `${element.path}/${element.id}`,
            title: element.getTitle(this.$i18n.locale),
            type: element.localize(this.$i18n.locale, 'piece:title'),
            origin: element.localize(this.$i18n.locale, 'origin:region'),
            collection: element.getMetadataTwo(this.$i18n.locale, false),
            contributors: element.getContributors(this.$i18n.locale),
            key: element.getKey(this.$i18n),
            'time-signature': element.signature.pretty,
            availableSources: {
              audioQuality: element.audioQuality,
              curatedAnalyses: element.curatedAnalyses,
              availableScores: element.availableScores,
              availableSources: element.availableSources,
              availableTracks: element.availableTracks,
              availableWaves: element.availableWaves,
              sortKey: element.availableSources + element.curatedAnalyses / 10,
            },
          } as unknown as Piece&TablePiece);
        }
      });

      this.items = this.items.sort(
        (a, b) => Piece.compareOpus(a as unknown as Piece, b as unknown as Piece),
      );
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      data.corpora?.forEach((corpus: any) => {
        this.loadCorpus(corpus, `${path}/${data.id}`, corpusFilter);
      });
      this.loading = false;
    },
    async tryLoadCorpus(path: string): Promise<CorpusData | null> {
      const corpusReq = await this.client.loadCorpusData(path);
      // TODO: display err on page
      switch (corpusReq.status) {
        case ClientStatus.Ok: return corpusReq.data;
        case ClientStatus.Unauth: {
          if (this.client.canLogin) {
            if (await showLogin(this.client)) {
              return this.tryLoadCorpus(path);
            }
          }
          await warnCorpusDataUnauth(path);
          break;
        }
        case ClientStatus.Missing: {
          const newPath = path.split('/');
          newPath.pop();
          let prefix = '';
          if (this.appName) {
            prefix = `/${this.appName}`;
          }
          this.$router.push(`${prefix}/explore/${newPath.join('/')}`); break;
        }
        case ClientStatus.NoResponse: await warnCorpusDataServer(); break;
        default: await warnCorpusDataOther();
      }
      return null;
    },
    async init() {
      if (this.items.length) this.items = [];
      if (this.title.length) this.title = '';
      if (this.corpusData !== null) this.corpusData = null;

      const corpusId = this.$route.params.corpusId || null;
      this.title = corpusId || this.$t('corpus-table.default-title').toString();

      try {
        this.loading = true;
        if (corpusId) {
          const corpusData = await this.tryLoadCorpus(corpusId);
          if (corpusData) {
            this.title = corpusData.getTitle(this.$i18n.locale);
            window.document.title = `${corpusData.getShortTitle(this.$i18n.locale)} - Dezrann`;
            this.corpusData = corpusData;
          }
        }
        const { data } = await this.client.loadCorpus();
        this.loadCorpus(data, undefined, corpusId);
      } catch (error) {
        // eslint-disable-next-line no-console
        console.error(error);
      }
    },
  },
});

</script>
